#!/usr/bin/python
import xmlrpclib, sys

def send(maily, f, host="http://localhost:8080/", username=None, password=None):
	import string
	
	s=xmlrpclib.Server(host, transport=None, username=username, password=password)
	
		
	f.seek(0)
	file = f.read()
	#debug
	#print file

	try:
		clientlocation = s.Control_Panel.Products.ZMailIn.getClientLocation(maily['to'])
	except xmlrpclib.ProtocolError,e:
		print "Fail: Protocol Error",e
		return 1
	
	if clientlocation=='Not Found':
		print 'Client Location Not Found:',maily['to']
		return 1
	else:	
		if clientlocation[0]=='/':
			clientlocation = clientlocation[1:]

		clientlocation = string.replace(clientlocation,'/','.')

		try:
			exec """client = s.%s""" % (clientlocation,) 
			result = client.postZMailMessage(file, replacePunctuation(maily['id']), maily['title'], maily['subject'], maily['date'], maily['to'], maily['sender'], maily['replyto'], maily['body'], maily['headers'])
		except xmlrpclib.ProtocolError,e:
			print "Fail: Protocol Error",e
			return 1
	
		#debug
		#print result
	
		if (result[-4:]!='OK!'):
			print 'Fail'
			return 1
		else:
			print 'Success'
			return 0
	
def replacePunctuation(txt):
	import string
	s = range(33,48)
	s.extend(range(58,65))
	s.extend(range(92,97))
	s.extend(range(123,127))
	for i in s:
		txt = string.replace(txt,chr(i),'_')

	return txt
	

if __name__ == '__main__':
	import zopeMailInConf
	import rfc822, StringIO
	
	f = sys.stdin
	sio = StringIO.StringIO(f.read())
	m = rfc822.Message(sio)
		
	myMail = {}
	myMail['headers']=m.items()
	myMail['body']=m.fp.read()
	myMail['id']=m['message-id'][1:-1]
	myMail['title']=''
	myMail['sender']=''
	myMail['replyto']=''
	myMail['subject']=''
	myMail['date']=''
	
	headerslist = [['subject','title'],['from','sender'],['reply-to','sender'],['subject','subject'],['date','date'],['to','to']]
	
	for header in headerslist:
		if m.has_key(header[0]):
			myMail[header[1]]=m[header[0]]
		
	if m.has_key('envelope-to'):
		myMail['to'] = m['envelope-to']
	else:
		print "No envelope-to header. Please configure your MTP"
		sys.exit(1)
	
	if send(myMail, sio, zopeMailInConf.host, zopeMailInConf.username, zopeMailInConf.password):
		# 73 is a standard error code.
		# It means EX_CANTCREAT
		sys.exit(73)
	else:
		sys.exit(0)